/*
	The customers include students ,employee ,companies ,banks 
	contractors , and any one else who is potential to make 
	a transaction with the cash sectioni
	its coincidence that account no and roll no are same 
	so don't worry over this issue

*/

--- profession should be student or employee only --Mitul
create table customers (account_no varchar2(8) primary key ,
						name       varchar2(20) not null,
						profession varchar2(10) not null,
						address    varchar2(40) not null,
						email	   varchar2(100) not null
						);

---  students,employee  table is self expalnatory 

create table student (roll   varchar2(8)   primary key,
					  name   varchar2(40)  not null,
	                  fees   number(7,2)   not null,
					  hostel number(2)     not null,
	                  room   number(3)     not null,
					  sex    varchar2(1)   check(sex in ('M','F'))
					);
create table employee(
						emp_code varchar2(8)   primary key,
						name     varchar2(40)  not null,
						dept     varchar2(10)  not null,
						desg     varchar2(12)  not null,
						sex      varchar2(1)   check(sex in ('M','F')),
						doj      date          not null
					 );


/*  table "Bills"  contains everything about the processed and 
	non processed bills .A batch process will run deleting old bills 
	and archiving them some where else 

*/

create table bills (bill_no      number(8)  primary key ,
					account_no   varchar2(8)  references customers,
					amount       number(8,2)  not null,
					balance      number(8,2)  not null,
					description  varchar2(40) not null,
					date_of_entry date        not null, 
					flag         varchar2(1)  check(flag in ('P','N'))
					);

					-- P=Processed (pending ) N=not Processed

/* 
   The actual transaction is captured in transactions table 
   it has both reciepts and payments 
 
*/


create table transactions (bill_no         number(8) references bills,
						   account_no      varchar2(8) references customers,
						   date_of_payment date not null,
						   mode_of_payment varchar2(3) 
						              check (mode_of_payment in('CSH','CHK')),
						   draft_no        number(10) not null,
						   payment_or_receipt varchar2(1) 
						                check(payment_or_receipt in('P','R')) 
						   );
					-- CSH = CASH CHK= CHECK 

/*
	The four below tables capture the essential dat required to prepare 
	salary bills for the employees ,only the persistent filds are given 
	space.
	every table accomadates extra fields to capture on the fly data 
	and why it is meant for .

*/

--- emp-code should reference customer in current model  -mitul

create table permanent_earnings ( emp_code     varchar2(8) primary key 
 								  references employee,
								  basic_pay    number(8,2) not null,
						 		  da           number(5,2) not null,
						 		  hr_alw       number(7,2) not null, 
						 		  add_duty_alw number(7,2) not null,
								  wash_alw     number(6,2) not null,
								  perm_earn_1  number(8,2),
								  descrption_1 varchar2(50),
						 		  perm_earn_2  number(8,2),
								  descrption_2 varchar2(50)
								  );

--- earning for the month = basic_pay+basic_pay*da+hr_alw+add_duty_alw+wash_alw+
---							extra_2+extra_1

--- note da is percentage of basic pay
--- descriptions are about the extra fields of earning 

--- permanent_earnings usually persist over one year at least
								  
create table temporary_earnings(
							  emp_code          varchar2(8) primary key
							  references employee, 
					  		  over_time_alw     number(7,2) not null,
					  		  children_edu_alw  number(6,2) not null,
							  temp_earn_1       number(7,2) not null,
							  description_1     varchar2(50),
							  temp_earn_2       number(7,2) not null,
							  description_2     varchar2(50)
					          );


--- temporary_earings = over_time_alw+children_edu_alw+temp_earn_2+temp_earn_1
							  

create table permanent_ded( 
							  emp_code        varchar2(8) primary key
							  references employee,
							  provident_fund  number(7,2) not null,
							  income_tax	  number(7,2) not null,
							  loan_interest   number(7,2) not null,
							  welfare_fund    number(7,2) not null,
							  staff_club_fees number(6,2) not null,
							  perm_ded_1      number(7,2) not null,
							  description_1   varchar2(50)
						);

--- permanent_ded = permanent_ded*basic_pay + income_tax + loan_interest + welfare_fund
---                 + staff_club_fees + perm_ded_1

--- note that pf is % of basic pay

create table temp_ded( 	
						  emp_code        varchar2(8) primary key
						  references employee,
						  elec_bill       number(7,2) not null,
						  water_bill      number(7,2) not null,
						  furniture_bill  number(7,2) not null,
						  personal_adv    number(7,2) not null,
						  description_adv varchar2(50),
						  proffesional_tax number(7,2) not null,
						  temp_ded_1      number(7,2) not null,
						  description_1   varchar2(50),
						  temp_ded_2      number(7,2) not null,
						  description_2   varchar2(50),
						  temp_ded_3      number(7,2) not null,
						  description_3   varchar2(50)
						);

--- personal advance could be any one of festval | vehicle | medical etc 
	

---- added on 10/29/99 15:47:43 
---- temporary table to keep track of salary bills made 
create table salary_bills (
						emp_code    varchar2(8) references employee,
						net_perm_earnings number(10,2) not null,
						net_temp_earnings number(10,2) not null,
						net_temp_ded	number(10,2) not null,
						net_perm_ded	number(10,2) not null,
						net_salary  number(10,2) not null,
						date_of_entry date,
						flag        varchar2(1)
						);

--- flag is for whether the bill is inserted in the bills table
						





