/**	This contains methods to prepare bills for salaries taking into
 *	account both permanent and temporary types
 *
*	whenever files are uploded containing the changes this file update 
 *	methods are used to set the fields in table salry_bills
 */


import java.io.*;
import java.util.Date;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
import java.lang.*;


class salaryBill {

	private Connection con;
	private Utility util;
	private Statement stmt;
	private PreparedStatement permearnInsert;
	private PreparedStatement tempearnInsert;
	private PreparedStatement permdedInsert;
	private PreparedStatement tempdedInsert;
	private PreparedStatement permearnUpdate;
	private PreparedStatement permdedUpdate;
	private PreparedStatement tempearnUpdate;
	private PreparedStatement tempdedUpdate;
	

	public void Set_Connection(Utility util) throws SQLException
	{
		this.con = util.giveConnection();
		this.util= util;
		this.permearnInsert = this.con.prepareStatement(
				"insert into permanent_earnings (emp_code,basic_pay,da,hr_alw,add_duty_alw,wash_alw,perm_earn_1,descrption_1,perm_earn_2,descrption_2) values(?,?,?,?,?,?,?,?,?,?)");

		this.tempearnInsert = this.con.prepareStatement(
				"insert into temporary_earnings (emp_code ,over_time_alw ,children_edu_alw, temp_earn_1,description_1,temp_earn_2,description_2) values(?,?,?,?,?,?,?)");

		this.tempdedInsert = this.con.prepareStatement(
				"insert into temp_ded(emp_code,elec_bill,water_bill ,furniture_bill, personal_adv,description_adv,proffesional_tax,temp_ded_1, description_1,temp_ded_2,description_2,temp_ded_3 ,description_3) values (?,?,?,?,?,?,?,?,?,?,?,?,?)");

		this.permdedInsert = this.con.prepareStatement(
				"insert into permanent_ded (emp_code,provident_fund, income_tax, loan_interest,welfare_fund,staff_club_fees,perm_ded_1, description_1) values(?,?,?,?,?,?,?,?)");
 
		this.permearnUpdate = this.con.prepareStatement(
				"update permanent_earnings set basic_pay=?,da=?,hr_alw=?,add_duty_alw=?, wash_alw=?,perm_earn_1=?,descrption_1=?, perm_earn_2=?,descrption_2=? where emp_code=?");
		this.permdedUpdate = this.con.prepareStatement(
				"update permanent_ded set provident_fund=?,income_tax=?,loan_interest=?, welfare_fund=?,staff_club_fees=?,perm_ded_1=?,description_1=?  where emp_code=?");
		this.tempearnUpdate = this.con.prepareStatement(
				"update temporary_earnings set over_time_alw=?,children_edu_alw=?,temp_earn_1=?, description_1=?, temp_earn_2=?,description_2=? where emp_code=?");
		this.tempdedUpdate = this.con.prepareStatement(
				"update temp_ded set elec_bill=?,water_bill=?,furniture_bill=?,personal_adv=?, description_adv=?,proffesional_tax=?, temp_ded_1=?,description_1=?, temp_ded_2=?,description_2=?, temp_ded_3=?,description_3=? where emp_code=?");
				
	}



	public void Insert_perm_earn
		(String emp_code,String basic_pay,String da,String hr_alw,String add_duty_alw,
		 String wash_alw,String perm_earn_1,String description_1,String perm_earn_2,
		 String description_2)
		{
			try{

				permearnInsert.setString(1,emp_code);
				permearnInsert.setFloat(2,this.util.toFloat(basic_pay));
				permearnInsert.setFloat(3,this.util.toFloat(da));
				permearnInsert.setFloat(4,this.util.toFloat(hr_alw));
				permearnInsert.setFloat(5,this.util.toFloat(add_duty_alw));
				permearnInsert.setFloat(6,this.util.toFloat(wash_alw));
				permearnInsert.setFloat(7,this.util.toFloat(perm_earn_1));
				permearnInsert.setString(8,description_1);
				permearnInsert.setFloat(9,this.util.toFloat(perm_earn_2));
				permearnInsert.setString(10,description_2);
				permearnInsert.executeUpdate();
			}
			catch (SQLException e)
			{
				System.out.println(e.toString());
			}
		}

	public void Update_perm_earn 
		(String emp_code,String basic_pay,String da,String hr_alw,String add_duty_alw,
		 String wash_alw,String perm_earn_1,String description_1,String perm_earn_2,
		 String description_2)
		{
			try{

				permearnUpdate.setString(10,emp_code);
				permearnUpdate.setFloat(1,this.util.toFloat(basic_pay));
				permearnUpdate.setFloat(2,this.util.toFloat(da));
				permearnUpdate.setFloat(3,this.util.toFloat(hr_alw));
				permearnUpdate.setFloat(4,this.util.toFloat(add_duty_alw));
				permearnUpdate.setFloat(5,this.util.toFloat(wash_alw));
				permearnUpdate.setFloat(6,this.util.toFloat(perm_earn_1));
				permearnUpdate.setString(7,description_1);
				permearnUpdate.setFloat(8,this.util.toFloat(perm_earn_2));
				permearnUpdate.setString(9,description_2);
				permearnUpdate.executeUpdate();

				float total = this.util.toFloat(basic_pay)*
								(1+this.util.toFloat(da)%100)+
								this.util.toFloat(hr_alw)+
								this.util.toFloat(add_duty_alw)+
								this.util.toFloat(wash_alw)+
								this.util.toFloat(perm_earn_1)+
								this.util.toFloat(perm_earn_2);

				PreparedStatement net = this.con.prepareStatement
					("update salary_bills set net_perm_earnings=? where emp_code=?");
				net.setFloat(1,total);
				net.setString(2,emp_code);
				net.executeUpdate();
			}
			catch (SQLException e)
			{
				System.out.println(e.toString());
			}
		}
	
	public void Insert_temp_earn
		(String emp_code,String over_time_alw,String children_edu_alw,
		 String temp_earn_1,String description_1,String temp_earn_2,
		 String description_2)
		{
			try{
				
				tempearnInsert.setString(1,emp_code);
				tempearnInsert.setFloat(2,this.util.toFloat(over_time_alw));
				tempearnInsert.setFloat(3,this.util.toFloat(children_edu_alw));
				tempearnInsert.setFloat(4,this.util.toFloat(temp_earn_1));
				tempearnInsert.setString(5,description_1);
				tempearnInsert.setFloat(6,this.util.toFloat(temp_earn_2));
				tempearnInsert.setString(7,description_2);
				tempearnInsert.executeUpdate();
			}
			catch(SQLException e)
			{
				System.out.println(e.toString());
			}
		}

	public void Update_temp_earn
		(String emp_code,String over_time_alw,String children_edu_alw,
		 String temp_earn_1,String description_1,String temp_earn_2,
		 String description_2)
		{
			try{
				
				tempearnUpdate.setString(7,emp_code);
				tempearnUpdate.setFloat(1,this.util.toFloat(over_time_alw));
				tempearnUpdate.setFloat(2,this.util.toFloat(children_edu_alw));
				tempearnUpdate.setFloat(3,this.util.toFloat(temp_earn_1));
				tempearnUpdate.setString(4,description_1);
				tempearnUpdate.setFloat(5,this.util.toFloat(temp_earn_2));
				tempearnUpdate.setString(6,description_2);
				tempearnUpdate.executeUpdate();

				float total = this.util.toFloat(over_time_alw)+
							  this.util.toFloat(children_edu_alw)+
							  this.util.toFloat(temp_earn_1)+
							  this.util.toFloat(temp_earn_2);

				PreparedStatement net = this.con.prepareStatement
					("update salary_bills set net_temp_earnings=? where emp_code=?");
				net.setFloat(1,total);
				net.setString(2,emp_code);
				net.executeUpdate();
			}
			catch(SQLException e)
			{
				System.out.println(e.toString());
			}
		}



	public void Insert_perm_ded 
		(String emp_code,String provident_fund,String income_tax,
		 String loan_interest,String welfare_fund,String staff_club_fees,
		 String perm_ded_1,String description_1)
		{
			try{	
			System.out.println(" perm ded");
			permdedInsert.setString(1,emp_code);
			permdedInsert.setFloat(2,this.util.toFloat(provident_fund));
			permdedInsert.setFloat(3,this.util.toFloat(income_tax));
			permdedInsert.setFloat(4,this.util.toFloat(loan_interest));
			permdedInsert.setFloat(5,this.util.toFloat(welfare_fund));
			permdedInsert.setFloat(6,this.util.toFloat(staff_club_fees));
			permdedInsert.setFloat(7,this.util.toFloat(perm_ded_1));
			permdedInsert.setString(8,description_1);
			permdedInsert.executeUpdate();
			}
			catch(SQLException e)
			{
				System.out.println(e.toString());
			}
		}
	
	public void Update_perm_ded 
		(String emp_code,String provident_fund,String income_tax,
		 String loan_interest,String welfare_fund,String staff_club_fees,
		 String perm_ded_1,String description_1)
		{
			try{	
			System.out.println(" perm ded");
			permdedUpdate.setString(8,emp_code);
			permdedUpdate.setFloat(1,this.util.toFloat(provident_fund));
			permdedUpdate.setFloat(2,this.util.toFloat(income_tax));
			permdedUpdate.setFloat(3,this.util.toFloat(loan_interest));
			permdedUpdate.setFloat(4,this.util.toFloat(welfare_fund));
			permdedUpdate.setFloat(5,this.util.toFloat(staff_club_fees));
			permdedUpdate.setFloat(6,this.util.toFloat(perm_ded_1));
			permdedUpdate.setString(7,description_1);
			permdedUpdate.executeUpdate();
				
			
			float total = this.util.toFloat(provident_fund)+
							  this.util.toFloat(income_tax)+
							  this.util.toFloat(loan_interest)+
							  this.util.toFloat(welfare_fund)+
							  this.util.toFloat(staff_club_fees)+
							  this.util.toFloat(perm_ded_1);

				PreparedStatement net = this.con.prepareStatement
					("update salary_bills set net_perm_ded=? where emp_code=?");
				net.setFloat(1,total);
				net.setString(2,emp_code);
				net.executeUpdate();
			}
			catch(SQLException e)
			{
				System.out.println(e.toString());
			}
		}
	
	
	public void Insert_temp_ded 
		(String	emp_code,String elec_bill,String water_bill,
		 String furniture_bill,
		 String personal_adv,String description_adv, String proffesional_tax,
		 String temp_ded_1,String description_1,String temp_ded_2,
		 String description_2,String temp_ded_3,String description_3)
		{
			try{
			tempdedInsert.setString(1,emp_code);
			tempdedInsert.setFloat(2,this.util.toFloat(elec_bill));
			tempdedInsert.setFloat(3,this.util.toFloat(water_bill));
			tempdedInsert.setFloat(4,this.util.toFloat(furniture_bill));
			tempdedInsert.setFloat(5,this.util.toFloat(personal_adv));
			tempdedInsert.setString(6,description_adv);
			tempdedInsert.setFloat(7,this.util.toFloat(proffesional_tax));
			tempdedInsert.setFloat(8,this.util.toFloat(temp_ded_1));
			tempdedInsert.setString(9,description_1);
			tempdedInsert.setFloat(10,this.util.toFloat(temp_ded_2));
			tempdedInsert.setString(11,description_2);
			tempdedInsert.setFloat(12,this.util.toFloat(temp_ded_3));
			tempdedInsert.setString(13,description_3);
			tempdedInsert.executeUpdate();
			}
			catch (SQLException e)
			{
				System.out.println(e.toString());
			}
		}
	
	public void Update_temp_ded 
		(String	emp_code,String elec_bill,String water_bill,
		 String furniture_bill,
		 String personal_adv,String description_adv, String proffesional_tax,
		 String temp_ded_1,String description_1,String temp_ded_2,
		 String description_2,String temp_ded_3,String description_3)
		{
			try{
				System.out.println("temporay ded");
			tempdedUpdate.setString(13,emp_code);
			tempdedUpdate.setFloat(1,this.util.toFloat(elec_bill));
			tempdedUpdate.setFloat(2,this.util.toFloat(water_bill));
			tempdedUpdate.setFloat(3,this.util.toFloat(furniture_bill));
			tempdedUpdate.setFloat(4,this.util.toFloat(personal_adv));
			tempdedUpdate.setString(5,description_adv);
			tempdedUpdate.setFloat(6,this.util.toFloat(proffesional_tax));
			tempdedUpdate.setFloat(7,this.util.toFloat(temp_ded_1));
			tempdedUpdate.setString(8,description_1);
			tempdedUpdate.setFloat(9,this.util.toFloat(temp_ded_2));
			tempdedUpdate.setString(10,description_2);
			tempdedUpdate.setFloat(11,this.util.toFloat(temp_ded_3));
			tempdedUpdate.setString(12,description_3);
			tempdedUpdate.executeUpdate();

				float total = this.util.toFloat(elec_bill)+
							  this.util.toFloat(water_bill)+
							  this.util.toFloat(furniture_bill)+
							  this.util.toFloat(personal_adv)+
							  this.util.toFloat(proffesional_tax)+
							  this.util.toFloat(temp_ded_1)+
							  this.util.toFloat(temp_ded_2)+
							  this.util.toFloat(temp_ded_3);

				PreparedStatement net = this.con.prepareStatement
					("update salary_bills set net_temp_ded=? where emp_code=?");
				net.setFloat(1,total);
				net.setString(2,emp_code);
				net.executeUpdate();
			}
			catch (SQLException e)
			{
				System.out.println(e.toString());
			}
		}
}	


